#!/usr/bin/python
# coding: iso-8859-15 
import RPi.GPIO as GPIO
import signal
import collections
import os
import sys
import smbus
import subprocess
import pygame
import math
import time
import datetime
import MySQLdb as mdb
import httplib, urllib
from time import *
from ctypes import c_short
from ctypes import c_byte
from ctypes import c_ubyte
from myconfignew import *
standaard_taal="nederlands"
GPIO.setmode(GPIO.BOARD)
GPIO.setwarnings(False)
GPIO.setup(sirene_pin, GPIO.OUT)
GPIO.setup(voed_relais_pin,GPIO.OUT)
GPIO.setup(initalarm,GPIO.OUT)
GPIO.setup(slaapmodus, GPIO.OUT)
GPIO.setup(slaapm_toggle,GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(reed_camperdeur, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(reed_slaap, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(reed_links, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(reed_rechts, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(reed_portier,GPIO.IN,pull_up_down=GPIO.PUD_UP)
#GPIO.setup(sens, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(led_slaap, GPIO.OUT)
GPIO.setup(parksens, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.output(initalarm,GPIO.LOW)
GPIO.output(slaapmodus,GPIO.LOW)


#definieer de overige variabelen die onafhankelijk zijn van de feitelijke installatie
myNegeermultilijst=[] # een geactiveerde sensor mag niet nog een keer alarm slaan voordat ie weer tot rust is gekomen
nu=time.time()
laatste_meting=nu-2000 #laatste meting Koeltemperatuur.
laatste=time.time()-verlooptijd
laatste_pas=time.time()
db = mdb.connect('localhost', 'root', '1Piano%', 'sensors');
cursor = db.cursor()
begin_dect=0
eerste=True
alarmfase=0
alarmaan=0
alarm=0
bijzonderheden=0
slaapmodus_actief=False
tweedekeer=False
alarmtype=0; # 0 is hoog, 1 is laag
wachttijd=park_duur
GPIO.output(voed_relais_pin,GPIO.LOW) # voeding voor parkeersensors is uit
bus = smbus.SMBus(1) # Rev 2 Pi uses 1

def end_read(signal,frame):
	global alarm
	global alarmaan
	print "Ctrl+C captured, ending read."
	alarm=1
	alarmaan=0
def to_seconds(timestr):
    seconds= 0
    for part in timestr.split(':'):
        seconds= seconds*60 + int(part)
    return seconds	

signal.signal(signal.SIGINT, end_read)
pygame.mixer.init()

def sms_zend(var4,toon):
	global push-id
	try:		
		msg= "Alarm sensor nr. "+var4+"\n\n"
		conn = httplib.HTTPSConnection("pushsafer.com:443")
		conn.request("POST", "/api", urllib.urlencode({
            "k": push-id, 
            "m": msg,                   # Message Text
            "t": msg,                     # Title of message
            "i": "1",                      # Icon number 1-98
            "s": toon,                     # Sound number 0-28
            "v": "1",                 # Vibration number 0-3
            "p": "",                   # Picture Data URL with Base64-encoded string
        }), { "Content-type": "application/x-www-form-urlencoded" })
		response = conn.getresponse()
	except IOError:
		return 0	
	

def vuldata(varfreq,varom,vartijd):
	try:
		if (databaseaan):
			SQL = "INSERT INTO alarm (frequentie,omschrijving,datum_tijd) VALUES (%s, %s,%s);" # Note: no quotes
			data = (varfreq,varom,vartijd)
			cursor.execute(SQL, data)
			db.commit()		
	except IOError:
		return 0		

def maakdatabase_leeg():
	try:	
		if (databaseaan):
			SQL = "TRUNCATE TABLE alarm"	
			cursor.execute(SQL)
			db.commit()				
	except IOError:
		return 0	
		
def vultemp(vartijd,varkoel):
	var1=0
	try:
		if (databaseaan):
			SQL = "DELETE FROM temperatuur LIMIT 1;" # Note: no quotes			
			cursor.execute(SQL)
			db.commit()		
			SQL = "INSERT INTO temperatuur(datum_tijd,koel) VALUES(%s,%s);" # Note: no quotes
			data = (vartijd,varkoel)
			cursor.execute(SQL, data)
			db.commit()	
			var1=1
	except IOError:
		return 0		
	return var1
	
def openconf(type):
	waarde=""
	if (type==1):
		try:
			bestand=open("/home/pi/alarmsys/myniveau.py","r")
			waarde=bestand.readline()
			bestand.close()
		except:
			waarde="";
	if (type==2):
		try:
			bestand=open("/home/pi/alarmsys/taalmodule.py","r")
			waarde=bestand.readline()
			bestand.close()
		except:
			waarde="";
	return waarde			
			
def fetch_koel():
	temperatures=[]
	temp = 0
	try:
		for polltime in range(0,3):
			text = '';
			while text.split("\n")[0].find("YES") == -1:
				tfile = open("/sys/bus/w1/devices/"+ koel_sensor+"/w1_slave")
				text = tfile.read()
				tfile.close()
				#time.sleep(1)
				secondline = text.split("\n")[1]
				temperaturedata = secondline.split(" ")[9]
				temperature = float(temperaturedata[2:])
				temperatures.append(temperature / 1000)
		avgtemperatures=sum(temperatures) / float(len(temperatures))
		temp="{0:.1f}".format(round(avgtemperatures,1))
		return temp
	except:
		return 0

def haaldatatemp():		
	kktemp=fetch_koel()	
	vultemp(datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S"),kktemp)
	return kktemp
	
def sound_waarschuwing(var1,var2,var3): # var1= type , var2 = inhoud, var 3 = duur bij sirene
	global soortdb	
	global alarmtype
	if var1=="sound_only":
		geluidsnum=var2	
	if var1=="reed":
		geluidsnum=0
	if var1=="park":
		if alarmtype==0:
			geluidsnum=var2
		else:
			geluidsnum=9
	if geluidsnum==0: #sirene		
		GPIO.output(sirene_pin,1) # sirene aan 
		time.sleep(var3) #gedurende var3 seconden
		GPIO.output(sirene_pin,0) # sirene uit 		
	if ((geluidsnum>0) and (geluidsnum<9)):
		try:
			geluidsfragment=path_geluid+sound[geluidsnum]			 			
			pygame.mixer.music.load(geluidsfragment)
			pygame.mixer.music.play()
			while pygame.mixer.music.get_busy() == True:
				continue
					
		except IOError:
			return 0
	
		
			
def testalarm(var1): #var1=1 slaapmodus var1=2: normale modus	
	var6=0
	if GPIO.input(reed_rechts)==1:
		var6=1
		reedstring='reed douche/keuken/dinette'
	if GPIO.input(reed_links)==1:
		var6=2
		reedstring='reed schuifraam/luik'
	if GPIO.input(slaapm_toggle)==0:
		if GPIO.input(reed_slaap)==1:
			var6=3	
			reedstring='reed slaapkamer'
	if GPIO.input(reed_camperdeur)==1:
		var6=4		
		reedstring='reed camperdeur'
	if GPIO.input(reed_portier)==1:
		var6=7
		reedstring='reed portier'			
	return var6


	
def checkwaarschuwing(var1,var2):
	global laatste
	global eerste
	global bijzonderheden
	global park_duur
	global verlooptijd
	global tweedekeer
	global begin_dect
	nusec=time.time()
	if var1>1:
		if eerste:
			sound_waarschuwing("park", 1,0)	
			vuldata(var2,"dichtbij",datetime.datetime.now().strftime("%H:%M:%S"))
			bijzonderheden +=1
			eerste=False
			laatste=nusec #tijd in seconden van de laatste waarschuwing
		else:
			if tweedekeer==False:
				if nusec-laatste>park_duur*2:
					sound_waarschuwing("park", 2,0)
					tweedekeer=True
					vuldata(var2,"dichtbij",datetime.datetime.now().strftime("%H:%M:%S"))
					bijzonderheden +=1
					laatste=nusec #tijd in seconden van de laatste waarschuwing
			else:
					vuldata(var2,"no sound",datetime.datetime.now().strftime("%H:%M:%S"))
					laatste=nusec #tijd in seconden van de laatste waarschuwing
	else:
		if var1>0:
			if eerste:
				if ((begin_dect==0) or (nusec-begin_dect>park_duur)):
					begin_dect=nusec
				else:
					if nusec-begin_dect>3:
						sound_waarschuwing("park", 1,0)	
						vuldata(var2,"veraf",datetime.datetime.now().strftime("%H:%M:%S"))				
						bijzonderheden +=1
						eerste=False
						laatste=nusec #tijd in seconden van de laatste waarschuwing				
			else:
				if tweedekeer==False:
					if nusec-laatste>park_duur*2:
						sound_waarschuwing("park", 2,0)	
						vuldata(var2,"veraf",datetime.datetime.now().strftime("%H:%M:%S"))
						bijzonderheden +=1
						tweedekeer=True
						laatste=nusec #tijd in seconden van de laatste waarschuwing
				else:
					vuldata(var2,"no sound",datetime.datetime.now().strftime("%H:%M:%S"))
					laatste=nusec #tijd in seconden van de laatste waarschuwing
					
	return 0
					
	

def checkpark(var2):
	global freq_ver
	global freq_bij
	teller=0
	tel2=0
	end_time = time.time() + 1.0; # time_time() should return the current time in seconds
	while (time.time() < end_time):
		status=GPIO.input(parksens) #stel vast of 1 of 0
		while ((GPIO.input(parksens)==status) and (time.time() < end_time)): # wacht tot een wijziging in status
			tel2=tel2+1
		teller=teller+1
	# print str(teller)
	return teller 
	
	
	
def my_reedcallback(channel):	
	global bijzonderheden	
	global alarmaan
	global myNegeermultilijst
	value_index=-1
	if GPIO.input(channel)==1:
		if alarmaan>0:
			if channel==reed_links:
				reedstring="reed links"				
			if channel==reed_rechts:
				reedstring="reed rechts"				
			if channel==reed_slaap:
				reedstring="reed slaap"				
			if channel==reed_portier:
				reedstring="reed portier"					
			if channel==reed_camperdeur:
				reedstring="reed camperdeur"				
			bijzonderheden +=1
			try:
				value_index = myNegeermultilijst.index(channel)
			except:
				value_index = -1
			if value_index==-1:
				myNegeermultilijst.append(channel)
				sms_zend(reedstring,"14")											
				sound_waarschuwing("reed",0,alarm_duurreed)	
	else:
		try:
			value_index = myNegeermultilijst.index(channel)
		except:
			value_index = -1	
		if value_index>-1:
			myNegeermultilijst.remove(channel)
			
	return 0



alarm=0
# hier begint de lees-routine
voeding_on=True
nu=time.time()
laatste_meting=nu
haaldatatemp()	
resultaat=testalarm(2)	
if resultaat==0:	
	alarmaan=1	
	bijzonderheden=0
	maakdatabase_leeg()			
	GPIO.output(initalarm,GPIO.HIGH) # zet het alarm aan
	eerste=True
	alarmfase=1	
try:
	while alarm==0:
		if monitoring>0:
			nu=time.time()
			if nu-laatste_meting>mon_interval:
				laatste_meting=nu					
				haaldatatemp()				
		#check of alarm aan wordt gezet		
		if GPIO.input(slaapmodus)==1:
			slaapmodus_actief=True
			GPIO.output(led_slaap,GPIO.HIGH)
			GPIO.output(initalarm,GPIO.HIGH)
		if GPIO.input(initalarm)==1:		
			time.sleep(0.5)
			if slaapmodus_actief==False:
				sound_waarschuwing("sound_only",8,0)	
			niv="hoog"
			resultaat=testalarm(2)
			if (resultaat==0):
				nivo=2
				if slaapmodus_actief==True: #nivo is altijd laag in slaapmodus
					nivo=0
				else:
					niv=openconf(1)
					if niv=="hoog":
						nivo=2
					else:
						if niv=="middel":
							nivo=1
						else:
							nivo=0				
				standaard_taal=openconf(2)
				if len(standaard_taal)==0:
					standaard_taal="engels"
				sound=['sirene',standaard_taal+'.mp3','eind'+standaard_taal+'.mp3','alarm'+standaard_taal+'.mp3','alarmaan.mp3','alarmtest.mp3','alarmuitzonder.mp3','alarmuitmet.mp3','start.mp3', 'leeg.mp3']
				print "niveau= "+str(nivo)
				if nivo>0: # alleen parkeersensoren aan als nivo is hoog of middel
					GPIO.output(voed_relais_pin,GPIO.HIGH)	
				bijzonderheden=0
				voeding_on=True									
				alarmaan=1				
				maakdatabase_leeg();
				time.sleep(5) #alarm op scherp na 10 sec	
				if slaapmodus_actief==False: #alleen boodschap als géén slaapmodus
					sound_waarschuwing("sound_only",4,0)
				eerste=True
				begindect=0
				alarmfase=1	
				GPIO.add_event_detect(reed_links, GPIO.BOTH, callback=my_reedcallback, bouncetime=500) 
				GPIO.add_event_detect(reed_rechts, GPIO.BOTH, callback=my_reedcallback, bouncetime=500) 
				if slaapmodus_actief==False:
					GPIO.add_event_detect(reed_slaap, GPIO.BOTH, callback=my_reedcallback, bouncetime=500) 
				GPIO.add_event_detect(reed_portier, GPIO.BOTH, callback=my_reedcallback, bouncetime=500) 	
				GPIO.add_event_detect(reed_camperdeur, GPIO.BOTH, callback=my_reedcallback, bouncetime=500)	
			else:				
				if slaapmodus_actief==False:
					sound_waarschuwing("sound_only",5,0)	
				slaapmodus_actief=False
				GPIO.output(slaapmodus,GPIO.LOW)
				GPIO.output(initalarm,GPIO.LOW)
				GPIO.output(voed_relais_pin,GPIO.LOW) # zet hoofdvoeding uit
		#hier start de subloop als alarm aangezet is		
		while alarmaan==1:
			try:
				if nivo>0:
					trig=0
					if GPIO.input(parksens)==1:
						#my_parksens() # controleer parkeersensoren	
						trig=checkpark(nivo)
						if trig>freq_bij:
							checkwaarschuwing(2,trig)
						else:
							if ((trig>freq_ver) and (nivo==2)):
								checkwaarschuwing(1,trig)	
							else:
								if ((trig>freq_pas) and (time.time()-laatste_pas>park_duur)):
									vuldata(trig,"passant",datetime.datetime.now().strftime("%H:%M:%S"))
									laatste_pas=time.time()
					if ((eerste==False) and (time.time()-laatste>verlooptijd)):
						eerste=True
						tweedekeer=False
						laatste=0
						begin_dect=0
						vuldata(0,"reset",datetime.datetime.now().strftime("%H:%M:%S"))
					if bijzonderheden>60: # er zijn meer dan 60 meldingen geweest; de camper roeptoetert dus, vandaar nu even de waarschuwingen uitzetten
						nivo=0 # ga naar niveau laag
						GPIO.output(voed_relais_pin,GPIO.LOW)	
					
				if ((slaapmodus_actief==True) and (GPIO.input(slaapmodus)==0)): 					
					GPIO.output(led_slaap,GPIO.LOW)
					GPIO.output(initalarm,GPIO.LOW)
				if GPIO.input(initalarm)==0:	
					alarmaan=0
					alarmset = -1					
					voeding_on=False	
					GPIO.output(voed_relais_pin,GPIO.LOW) # geen voeding meer aan parkeersensors
					if slaapmodus_actief==False:
						if  bijzonderheden==0: # de lijst is leeg - behoudens de opening van de deur om alarm uit te zetten - en dus geen alarm afgegaan
							sound_waarschuwing("sound_only",6,0)
						else:
							sound_waarschuwing("sound_only",7,0)		
					slaapmodus_actief=False																
					GPIO.remove_event_detect(reed_links)
					GPIO.remove_event_detect(reed_rechts)
					GPIO.remove_event_detect(reed_portier)
					GPIO.remove_event_detect(reed_slaap)
					GPIO.remove_event_detect(reed_camperdeur)																		
											
			except KeyboardInterrupt:
				raise
			#hier eindigt de alarm-loop	
			
except KeyboardInterrupt:
	raise
#hier eindigt de hoofdroutine
db.close()
GPIO.cleanup()

